--lib.4gl  library of functions  
SCHEMA portaldb

--exer 5_3 moved myinit to this library
--         This is now the DefaultInitializer for forms

FUNCTION myinit(f)
  DEFINE f      ui.Form,
         n      om.DomNode,
         f_name STRING
  
-- if the form is named custform, then extend it    
  LET n = f.getNode()
  LET f_name = n.getAttribute("name")
  IF f_name = "custform" THEN
    CALL extend_form(n)
  END IF
 
-- call these methods for all the forms 
  CALL ui.Interface.LoadStyles("mystyles")

  CALL ui.Interface.LoadActionDefaults("mydefaults")

 # CALL ui.Interface.LoadToolBar("mytoolbar")

END FUNCTION

--    This function is called from myinit
FUNCTION Extend_Form(d_form)

	DEFINE
		d_form		om.DomNode,
		d_box		om.DomNode,
		d_node		om.DomNode


--  Skip if form is NULL ---
	IF d_form IS NULL
	THEN
		RETURN
	END IF

---	Look for a BOX container ---
	LET d_box = d_form.getFirstChild()
	WHILE d_box IS NOT NULL
		IF d_box.getTagName() = "VBox"
		OR d_box.getTagName() = "HBox"
		THEN
			EXIT WHILE
		END IF
		LET d_box = d_box.getNext()
	END WHILE

--      End function if there is no VBox or HBox node 
	IF d_box IS NULL
	THEN
		RETURN
	END IF

--      Create a new group on form ---
	LET d_node = d_box.createChild("Group")
	CALL d_node.setAttribute("text", "Extension")
	CALL d_node.setAttribute("name", "form_extension")
	CALL d_node.setAttribute("width", 50)
	CALL d_node.setAttribute("height", 1)

--  Add some text ----
	LET d_node = d_node.createChild("Label")
	CALL d_node.setAttribute("posX", 1)
	CALL d_node.setAttribute("posY", 0)
	CALL d_node.setAttribute("width", 10)
	CALL d_node.setAttribute("text",
		"(c) Copyright Four Js Development Tools")
	CALL d_node.setAttribute("color", "Magenta")

END FUNCTION


-- ex5_2 Create node list and process it recursively
--       This function is called from MAIN with no parameters

FUNCTION change_labels()

   DEFINE
	d_node		om.DomNode,
	d_list		om.NodeList,
	p_window	ui.Window,
	i               SMALLINT
		
 	LET p_window =  ui.Window.getCurrent()
	LET d_node = p_window.getNode()
        LET d_list = d_node.selectByTagName("Label")
        
        FOR i = 1 to d_list.getLength()
          LET d_node = d_list.Item(i)
          CALL d_node.setAttribute("color", "Red")
        END FOR
        
END FUNCTION
        
{ -- Alternative solution using getFirstChild and getNext methods 
  -- Note that this solution requires you to call the function
  -- from MAIN passing a NULL parameter.  

FUNCTION change_labels(d_node)

    DEFINE
	d_node		om.DomNode,
	d_child		om.DomNode,
	p_window	ui.Window
     
    
--- If d_node is NULL, then start at current Window ---
     	IF d_node IS NULL THEN
	LET p_window =  ui.Window.getCurrent()
	LET d_node = p_window.getNode()
     	END IF       
---    Change color if it's a Label ---
	IF d_node.getTagName() = "Label" THEN
    	  CALL d_node.setAttribute("color", "Red")
	END IF
---   Do the kids ---
	LET d_child = d_node.getFirstChild()
	WHILE d_child IS NOT NULL
		CALL change_Labels(d_child)
		LET d_child = d_child.getNext()
	END WHILE

END FUNCTION

}

--Ex 5_1 Hide a field. Find node using ui.Window.findNode() 

FUNCTION Hide_Field(p_field, p_label)

	DEFINE
		p_field		STRING,
		p_label	 	STRING,	
		p_window	ui.Window,
		w_node		om.DomNode,
		fd_node		om.DomNode,
		l_node		om.DomNode

	LET p_window = ui.Window.getCurrent()
	LET w_node = p_window.getNode()
--Pinpoint the contact_name field with ui.Window.findNode()
--	LET fd_node = p_window.findNode("FormField", "customer.contact_name")
	LET fd_node = p_window.findNode("FormField", p_field)
        IF fd_node IS NOT NULL THEN
		CALL fd_node.setAttribute("hidden", TRUE)
	END IF

--Pinpoint the label with ui.Window.findNode()
--      LET l_node = p_window.findNode("Label", "lab1")
	LET l_node = p_window.findNode("Label", p_label)
	IF l_node IS NOT NULL THEN
   	   CALL l_node.setAttribute("hidden", TRUE)

	END IF
END FUNCTION





--Exer 4_4 Disable/enable actions

FUNCTION setup_actions(d, query_ok)
  DEFINE d ui.Dialog,
         query_ok SMALLINT
  CALL d.setActionActive("next",query_ok)
  CALL d.setActionActive("previous",query_ok)
 END FUNCTION
 
 

